don/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('', include('web.urls')),
    path('api/', include('don_api.urls')),
]

if settings.DEBUG:
    urlpatterns += [
        path('admin/', admin.site.urls),
        path("__debug__/", include("debug_toolbar.urls")),
    ]

web/urls.py
from django.conf import settings
from django.urls import path
from django.views import defaults as default_views
from django.views.generic.base import RedirectView

from .views.api import (
    APIListView, APIDetailView, APISpecificationView, APIAddView, 
    APIAddSuccessView, APIValidatorReportsView, OpenApiSpecGenerator
)
from .views.article import ArticleListView, ArticleDetailView
from .views.generic import TemplateView
from .views.index import IndexView
from .views.organization import OrganizationDetailView, OrganizationListView
from .views.repository import RepositoryListView, RepositoryAddView, RepositoryAddSuccessView
from .views.statistics import StatisticsView


app_name = "web"


urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("apis", APIListView.as_view(), name="api_list"),
    path("apis/toevoegen", APIAddView.as_view(), name="api_add"),
    path("apis/toevoegen/succes", APIAddSuccessView.as_view(), name="api_add_success"),
    path("apis/<slug:api_id>", APIDetailView.as_view(), name="api_detail"),
    path("apis/<slug:api_id>/score-details", APIValidatorReportsView.as_view(), name="api_validator_reports"),
    path("apis/<slug:api_id>/specificatie/<str:environment_name>", APISpecificationView.as_view(),
         name="api_specification"),
    path("organisaties", OrganizationListView.as_view(), name="organization_list"),
    path("organisaties/<slug:slug>", OrganizationDetailView.as_view(), name="organization_detail"),
    path("repositorys", RepositoryListView.as_view(), name="repository_list"),
    path("artikelen", ArticleListView.as_view(), name="article_list"),
    path("artikelen/<slug:slug>", ArticleDetailView.as_view(), name="article_detail"),
    path("toevoegen/repository", RepositoryAddView.as_view(), name="repository_add"),
    path("toevoegen/repository/succes", RepositoryAddSuccessView.as_view(), name="repository_add_success"),
    path("statistieken", StatisticsView.as_view(), name="statistics"),
    path("tools/oas-generator", OpenApiSpecGenerator.as_view(), name="oas_generator"),
    path("contact", TemplateView.as_view(title="Contact", template_name="contact.html"), name="contact"),
    path("over", TemplateView.as_view(
        title="Over Developer Overheid",
        description="Eén centrale plek voor de developer die voor of met de overheid ontwikkelt",
        template_name="content/about.html",
    ), name="content_about"),
    path("privacy", TemplateView.as_view(title="Privacyverklaring", template_name="content/privacy.html"),
         name="content_privacy"),
    path(".well-known/security.txt", RedirectView.as_view(url="https://www.ncsc.nl/.well-known/security.txt")),
]


if settings.DEBUG:
    urlpatterns += [
        path("error/400", default_views.bad_request, {"exception": Exception("Bad request")}),
        path("error/404", default_views.page_not_found, {"exception": Exception("Page not Found")}),
        path("error/500", default_views.server_error),
    ]

core/models/api.py
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

from . import MAX_ENUM_LENGTH, MAX_TEXT_LENGTH, MAX_URL_LENGTH

from .organization import Organization
from .topic import Topic
from .validator import ForeignValidatorReport, BaseValidatorReport, ValidatorReportsMixin


class API(ValidatorReportsMixin["APIValidatorReport"], models.Model):
    class APIType(models.TextChoices):
        UNKNOWN = 'unknown', 'Onbekend'
        ODATA = 'odata', 'OData'
        REST_JSON = 'rest_json', 'REST/JSON'
        REST_XML = 'rest_xml', 'REST/XML'
        SOAP_XML = 'soap_xml', 'SOAP/XML'
        GRPC = 'grpc', 'gRPC'
        GRAPHQL = 'graphql', 'GraphQL'
        SPARQL = 'sparql', 'SPARQL'
        WFS = 'wfs', 'WFS'
        WMS = 'wms', 'WMS'

    class APIAuthentication(models.TextChoices):
        UNKNOWN = 'unknown', 'Unknown'
        NONE = 'none', 'None'
        MUTUAL_TLS = 'mutual_tls', 'Mutal TLS'
        API_KEY = 'api_key', 'API key'
        IP_ALLOW_LIST = 'ip_allow_list', 'IP allow list'
        OAUTH2 = "oauth2", "OAuth 2.0"

    api_id = models.CharField(max_length=MAX_TEXT_LENGTH, unique=True)
    description = models.TextField()
    organization = models.ForeignKey(
        Organization, verbose_name=_("organization"), on_delete=models.PROTECT)
    service_name = models.CharField(max_length=MAX_TEXT_LENGTH)
    api_type = models.CharField(
        max_length=MAX_ENUM_LENGTH,
        choices=APIType.choices,
        default=APIType.UNKNOWN
    )
    api_authentication = models.CharField(
        max_length=MAX_ENUM_LENGTH,
        choices=APIAuthentication.choices,
        default=APIAuthentication.UNKNOWN
    )
    is_reference_implementation = models.BooleanField(default=False)

    contact_email = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    contact_phone = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    contact_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    terms_government_only = models.BooleanField(null=True)
    terms_pay_per_use = models.BooleanField(null=True)
    terms_uptime_guarantee = models.DecimalField(
        null=True,
        decimal_places=6,
        max_digits=8,
    )
    terms_support_response_time = models.PositiveIntegerField(
        help_text='Measured in number of workdays',
        null=True,
    )

    forum_vendor = models.CharField(max_length=MAX_ENUM_LENGTH, blank=True)
    forum_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    discourse_topic_url = models.CharField(max_length=MAX_URL_LENGTH, blank=True)

    badges = models.ManyToManyField(
        'Badge',
        through='APIBadge',
        related_name='apis',
    )
    referenced_apis = models.ManyToManyField(
        'self',
        through='Relation',
        symmetrical=False,
        related_name='referenced_by_apis',
    )
    topics = models.ManyToManyField(Topic)

    def __str__(self):
        return self.api_id

    def get_absolute_url(self):
        return reverse("web:api_detail", kwargs={"api_id": self.api_id})

    def get_production_environment(self):
        return self.environments.filter(name=Environment.EnvironmentType.PRODUCTION).first()

    ADR_TESTABLE_TYPES = (APIType.REST_JSON.ODATA, APIType.REST_JSON, APIType.REST_XML)
    """API's of these types can be tested on API Design Rules"""

    def is_adr_testable(self):
        return self.api_type in self.ADR_TESTABLE_TYPES

    class Meta:
        verbose_name = _("API")
        verbose_name_plural = _("APIs")


class Environment(models.Model):
    class EnvironmentType(models.TextChoices):
        PRODUCTION = 'production', 'Production'
        ACCEPTANCE = 'acceptance', 'Acceptance'
        TEST = 'test', 'Test'
        DEMO = 'demo', 'Demo'

    name = models.CharField(max_length=MAX_ENUM_LENGTH, choices=EnvironmentType.choices)
    api_url = models.URLField(max_length=MAX_URL_LENGTH)
    specification_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)
    documentation_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.CASCADE,
        related_name='environments',
    )

    def __str__(self):
        return f"{self.name} - {self.api_url}"


class Relation(models.Model):
    TYPE_REFERENCE_IMPLEMENTATION = "reference-implementation"

    name = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    from_api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.CASCADE,
        related_name='relations_from',
    )
    to_api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.PROTECT,
        related_name='relations_to',
    )

    def __str__(self):
        return f'{self.from_api_id} {self.name} {self.to_api_id}'


class APIValidatorReport(BaseValidatorReport):
    api = ForeignValidatorReport(API)

web/templates/partials/api_item.html
{% load don_extras %}
<li class="card card--padding-md card--horizontal mb-4">
    <div class="card__body">
        <div class="card__left">
            <a href="{% url 'web:api_detail' api_id=api.api_id %}" class="card__link">
                <h4 class="card__title">{{ api.service_name }}</h4>
            </a>
            <a href="{{ api.organization.get_absolute_url }}" class="card__sub-title">{{ api.organization.name }}</a>
            {% if api.description %}
            <p class="card__description mb-0">{{ api.description | truncatewords:42 }}</p>
            {% endif %}
            {% if api.topics.all %}
            <ul class="topic-list topic-list--multiple-lines mt-3">
                {% for name in api.topics.all %}
                <li>
                    <a href="{{ request.path_info }}?thema={{ name }}" class="topic-pill pill--clickable">{{ name }}</a>
                </li>
                {% endfor %}
            </ul>
            {% endif %}
        </div>
        <div class="card__right">
            <div class="pill pill--white pill--sm">
                {{ api.get_api_type_display }}
            </div>
            {% if api.latest_validator_reports.count %}
            <div class="card__right__grades mt-4 ml-3">
                {% for validator_report in api.latest_validator_reports %}
                {% score_pie validator_report.report is_large=False %}
                {% endfor %}
            </div>
            {% endif %}
        </div>
    </div>
</li>

web/templates/partials/api_list_results.html
<div class="filters">{% include "partials/facet_filters.html" %}</div>
<div class="results">
    <div class="results__header">
        {% if paginator.count %}<span class="results-count filter-hx-indicator">{{ paginator.count }} API{{ paginator.count | pluralize:"'s" }}</span>{% endif %}
        <a href="{% url 'web:api_add' %}" class="button button--add-icon">API toevoegen</a>
    </div>
    <div class="filter-hx-indicator filter-spinner mb-04">
        <div class="spinner"></div>
    </div>
    {% if paginator.count %}
        <ul class="results__list item-list filter-hx-indicator">
            {% for api in object_list %}
                {% include "partials/api_item.html" with api=api %}
            {% endfor %}
        </ul>
        {% include "partials/paginator.html" %}
    {% else %}
        Geen API's gevonden.
    {% endif %}
</div>

web/templates/partials/article_list.html
{% load i18n %}
<ol class="article-list my-md" style="--grid-n-columns: {{ columns }}">
    {% for article in article_list %}
    <li class="article-item">
        <h2 class="article-item__title">
            <a href="{% url 'web:article_detail' slug=article.slug %}">{{ article.title }}</a>
        </h2> 
        <p class="article-item__published_at">Gepubliceerd op: {% language "nl" %}{{ article.published_at }}{% endlanguage %}</p>
        <p>{{ article.summary }}</p>
    </li>
    {% endfor %}
</ol>

web/templates/partials/breadcrumb.html
<nav class="breadcrumb mb-4" aria-label="Breadcrumb">
    <ul>
        <li>
            <a href="{% url 'web:index' %}">Home</a>
        </li>
        {% for breadcrumb in breadcrumbs %}
        {% if forloop.last %}
        <li>
            <a aria-current="page" href="{{ breadcrumb.url }}">{{ breadcrumb.title }}</a>
        </li>
        {% else %}
        <li>
            {% if breadcrumb.url %}
            <a href="{{ breadcrumb.url }}">{{ breadcrumb.title }}</a>
            {% else %}
            <span>{{ breadcrumb.title }}</span>
            {% endif %}
        </li>
        {% endif %}
        {% endfor %}
    </ul>
</nav>

web/templates/partials/external_link.html
{% load static %}
<a href="{{ href }}" target="_blank" rel="noopener noreferrer">
    {{ title }}
    <svg class="icon icon--sm ml-1">
        <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-external-link" />
    </svg>
</a>

web/templates/partials/facet_filters.html
{% load static %}
<form class="filter-form"
      action="{{ request.path_info }}"
      hx-boost="true"
      hx-target="#list-results"
      hx-trigger="submit, change delay:500ms"
      hx-indicator=".filter-hx-indicator">
    <div class="filter-form__query">
        <label for="query">{{ search_label }}</label>
        <div class="search-field">
            <input id="query"
                   type="search"
                   name="q"
                   value="{{ form.search_text }}"
                   placeholder="Voer een zoekterm in">
            <svg viewBox="0 0 12 12">
                <path d="M8.576 7.547h-.542l-.192-.185A4.44 4.44 0 0 0 8.92 4.46a4.46 4.46 0 1 0-4.46 4.46 4.44 4.44 0 0 0 2.903-1.078l.185.192v.542L10.977 12 12 10.978l-3.424-3.43zm-4.116 0A3.083 3.083 0 0 1 1.372 4.46 3.083 3.083 0 0 1 4.46 1.372 3.083 3.083 0 0 1 7.547 4.46 3.083 3.083 0 0 1 4.46 7.547z" fill="#757575" fill-rule="nonzero">
                </path>
            </svg>
            {% if form.topic %}
            <div class="filter-form__query__topic">
                <input name="thema" value="{{ form.topic }}" type="hidden">
                <a href="{{ request.path_info }}{{ form.topic_remove_query }}" class="pill pill--white pill--clickable pill--lg">{{ form.topic }} <span class="pill__close">&#x2715</span></a>
            </div>
            {% endif %}
        </div>
        <button class="button filter-form__filter-toggle js-click-to-toggle"
                aria-expanded="false"
                data-label-target-hidden="Verberg filters"
                data-label-target-shown="Toon filters"
                aria-controls="js-filters"
                type="button">Toon filters</button>
    </div>
    <div id="js-filters" class="filter-form-wrapper">
        <div class="filter-form__facets">
            {% for field_name, field in form.fields.items %}
                <div class="filter-form__facets__facet mb-md" id="js-list-{{field_name}}">
                    <h3 class="mb-2">{{ field.label }}</h3>
                    <ul class="checkbox-list mt-0 mb-0" >
                        {% for option in field.options %}
                            <li class="checkbox-list__option {% if forloop.counter > 10 %}checkbox-list__option--hidden-initially{% endif %}"
                                {% if not option.count %}aria-disabled="true"{% endif %}>
                                <input id="{{ field_name }}_{{ option.value }}"
                                    name="{{ field_name }}"
                                    value="{{ option.value }}"
                                    type="checkbox"
                                    {% if option.selected and option.count %}checked{% endif %}
                                    {% if not option.count %}disabled{% endif %}>
                                <label for="{{ field_name }}_{{ option.value }}">
                                    {{ option.label }} <small>({{ option.count }})</small>
                                </label>
                            </li>
                        {% endfor %}
                    </ul>
                    {% if field.options|length > 10 %}
                        <button type="button" class="filter-form__facets__facet__show-more-button js-mutate-classname-of-target"
                            aria-controls="js-list-{{ field_name }}"
                            data-css-classname="filter-form__facets__facet--collapsed"
                            data-action="add"
                            href="#">
                            <svg class="icon icon--sm mr-3">
                                <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-caret-down-filled" />
                            </svg>
                            Meer opties
                        </button>
                    {% endif %}
                    {% if field.options|length > 10 %}
                        <button type="button" class="filter-form__facets__facet__show-less-button js-mutate-classname-of-target"
                            aria-controls="js-list-{{ field_name }}"
                            data-css-classname="filter-form__facets__facet--collapsed"
                            data-action="remove"
                            href="#">
                            <svg class="icon icon--sm mr-3">
                                <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-caret-up-filled" />
                            </svg>
                            Minder opties
                        </button>
                    {% endif %}
                </div>
            {% endfor %}
        </div>
        <button type="submit" class="button mt-4 w-100">Filter</button>
    </div>
</form>

web/templates/partials/main_navigation.html
{% load static %}
<header class="header">
    <div class="container header__container">
        <a class="header__container__logo" href="{% url 'web:index' %}"
            {% if request.resolver_match.view_name == "web:index" %} aria-current="page"{% endif %}>
            <img src="{% static 'images/logo.svg' %}" width="28" alt="Logo" class="mr-3">
            Developer Overheid
        </a>
        <nav class="header__container__links">
            <ul aria-label="Website navigatie" class="header__container__links__internal">
                <li>
                    <a class="header__container__links__internal__link {% if 'web:api_' in request.resolver_match.view_name %}active{% endif %}"
                        href="{% url 'web:api_list' %}"
                        {% if request.resolver_match.view_name == 'web:api_list' %} aria-current="page" {% endif %}>
                        API's
                    </a>
                </li>
                <li>
                    <a class="header__container__links__internal__link {% if 'web:repository_' in request.resolver_match.view_name %}active{% endif %}"
                        href="{% url 'web:repository_list' %}"
                        {% if request.resolver_match.view_name == 'web:repository_list'  %} aria-current="page" {% endif %}>
                        Repository's
                    </a>
                </li>
                <li>
                    <a href="https://community.developer.overheid.nl/" class="button button--primary my-sm"  aria-label="Onze community">
                        Community
                        <svg class="buton__icon button__icon--last icon icon--md" aria-hidden="true">
                            <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-messages" />
                        </svg>
                    </a>
                </li>
            </ul>
        </nav>
    </div>
</header>

web/templates/partials/mobile_navigation.html
{% load static don_extras %}
<div id="wrapper" class="mobile-navigation">
    <div class="mobile-navigation__backdrop mobile-navigation-close-on-click" id="mobile-navigation-backdrop"></div>
    <div role="dialog"
         aria-label="Subnavigatie"
         id="mobile-navigation-drawer"
         class="mobile-navigation__drawer">
        <div class="mobile-navigation__drawer__header">
            <button type="button"
                    title="Navigatie sluiten"
                    class="mobile-navigation__drawer__header__close-btn mobile-navigation-close-on-click">
            </button>
        </div>
        <ul class="mobile-navigation__drawer__navigation">
            <li>
                <a href="https://community.developer.overheid.nl/" target="_blank" rel="noopener noreferrer">
                    Onze community
                    <img class="mobile-navigation__drawer__navigation__external ml-1" src="{% static 'images/icons/external-link.svg' %}" width="16" height="16" aria-hidden="true">
                </a>
                <img src="{% static 'images/icons/chevron-right.svg' %}" width="16" height="16" aria-hidden="true">
            </li>
            <li>
                <a href="https://gitlab.com/commonground/don/developer.overheid.nl" target="_blank" rel="noopener noreferrer">
                    GitLab
                    <img class="mobile-navigation__drawer__navigation__external ml-1" src="{% static 'images/icons/external-link.svg' %}" width="16" height="16" aria-hidden="true">
                </a>
                <img class="mobile-navigation__drawer__navigation__external" src="{% static 'images/icons/chevron-right.svg' %}" width="16" height="16" aria-hidden="true">
            </li>
            <li>
                <img src="{% static 'images/icons/chevron-right.svg' %}" width="16" height="16" aria-hidden="true">
            </li>
            <li>
                <a href="{% url 'web:statistics' %}"{% if request.resolver_match.view_name == 'web:statistics' %} class="active"{% endif %}>
                    Statistieken
                </a>
                <img src="{% static 'images/icons/chevron-right.svg' %}" width="16" height="16" aria-hidden="true">
            </li>
            <li>
                <a href="{% url 'web:content_about' %}"{% if request.resolver_match.view_name == 'web:content_about' %} class="active"{% endif %}>
                    Over
                </a>
                <img src="{% static 'images/icons/chevron-right.svg' %}" width="16" height="16" aria-hidden="true">
            </li>
        </ul>
    </div>
    <nav class="mobile-navigation__navigation" aria-label="Hoofdnavigatie">
        <a href="{% url 'web:index' %}" class="mobile-navigation__navigation__button{% if request.resolver_match.view_name == 'web:index' %} active{% endif %}" >
            <span>Home</span>
            <svg width="24" height="24" viewBox="0 0 24 24">
                <path d="M19,21 L5,21 C4.44771525,21 4,20.5522847 4,20 L4,11 L1,11 L11.327,1.612 C11.7085185,1.26485664 12.2914815,1.26485664 12.673,1.612 L23,11 L20,11 L20,20 C20,20.5522847 19.5522847,21 19,21 Z M6,19 L18,19 L18,9.157 L12,3.703 L6,9.157 L6,19 Z" fill="#757575" fill-rule="nonzero"></path>
            </svg>
        </a>
        <a href="{% url 'web:api_list' %}" class="mobile-navigation__navigation__button{% if 'web:api_' in request.resolver_match.view_name %} active{% endif %}">
            <span>API's</span>
            <svg width="24" height="24" viewBox="0 0 24 24">
                <path d="M15,1.9999938 C16.4293537,1.9999938 17.7501755,2.76237671 18.4647473,4.00029394 C19.1793191,5.23821118 19.1790342,6.76334979 18.464,8.001 L23,7.9999938 L23,9.9999938 L21,9.9999938 L21,19.9999938 C21,20.5522847 20.5522847,20.9999938 20,20.9999938 L4,20.9999938 C3.44771525,20.9999938 3,20.5522847 3,19.9999938 L3,9.9999938 L1,9.9999938 L1,7.9999938 L5.536,8.001 C4.50816088,6.22118917 4.99641446,3.95208799 6.6653342,2.75255193 C8.33425394,1.55301586 10.6406303,1.81347679 12,3.355 C12.7578482,2.49189847 13.8514035,1.997976 15,1.9999938 Z M11,10 L5,10 L5,19 L11,19 L11,10 Z M19,10 L13,10 L13,19 L19,19 L19,10 Z M9,3.99997958 C7.92117082,3.99517218 7.03293687,4.84685865 6.99245826,5.92493898 C6.95197965,7.00301931 7.77384631,7.91891482 8.85,7.995 L9,8 L11,8 L11,6 C11.0000422,5.0123981 10.2792023,4.17262169 9.303,4.023 L9.149,4.005 L9,3.99997958 Z M15,3.9999999 C13.9533752,3.99966878 13.0834968,4.80632296 13.005,5.85 L13,5.9999999 L13,7.9999999 L15,7.9999999 C16.0466248,8.00033122 16.9165032,7.19367704 16.995,6.15 L17,5.9999999 C17,4.8954305 16.1045695,3.9999999 15,3.9999999 Z" fill="#757575" fill-rule="nonzero"></path>
            </svg>
        </a>
        <a href="{% url 'web:repository_list' %}" class="mobile-navigation__navigation__button{% if request.resolver_match.view_name == 'web:repository_list' %} active{% endif %}">
            <span>Repository's</span>
            <svg width="24" height="24" viewBox="0 0 24 24">
                <path fill="rgb(117, 117, 117)" d="M24 12l-5.657 5.657-1.414-1.414L21.172 12l-4.243-4.243 1.414-1.414L24 12zM2.828 12l4.243 4.243-1.414 1.414L0 12l5.657-5.657L7.07 7.757 2.828 12zm6.96 9H7.66l6.552-18h2.128L9.788 21z"></path>
            </svg>
        </a>
        <button type="button"
                id="mobile-navigation-toggle"
                class="mobile-navigation__navigation__button"
                aria-expanded="false"
                aria-controls="mobile-navigation-drawer">
            <span>Meer</span>
            <img src="{% static 'images/icons/dots.svg' %}" width="24" height="24" alt="">
        </button>
    </nav>
</div>

web/templates/partials/repository_list_results.html
{% load don_extras %}
<div class="filters">{% include "partials/facet_filters.html" %}</div>
<div class="results">
    <div class="results__header">
        {% if paginator.count %}<span class="results-count filter-hx-indicator">{{ paginator.count }} repository{{ paginator.count | pluralize:"'s" }}</span>{% endif %}
        <a href="{% url 'web:repository_add' %}" class="button button--add-icon">Repository toevoegen</a>
    </div>
    <div class="filter-hx-indicator filter-spinner mb-04">
        <div class="spinner"></div>
    </div>
    {% if paginator.count %}
        <ul class="results__list item-list filter-hx-indicator ">
            {% for repository in repository_list %}
                {% repository_item repository %}
            {% endfor %}
        </ul>
        {% include "partials/paginator.html" %}
    {% else %}
        Geen repository's gevonden.
    {% endif %}
</div>

web/templates/partials/score_pie.html
{% if is_large %}<div class="score-block score-block--{{ class_name }} card__cell">{% endif %}
    <div
        title="{{ ruleset_title }}"
        class="pie-chart pie-chart--full pie-chart--score-{{ class_name }} {% if is_large %}pie-chart--large{% endif %} ">
        <div class="pie-chart__pie">
            <svg viewBox="0 0 1 1">
                <circle cx="0.5" cy="0.5" r="0.44285714285714284" stroke="#9E9E9E" stroke-width="0.11428571428571428"
                    stroke-dasharray="2.782553493179531 2.782553493179531" stroke-dashoffset="{{ stroke_dashoffset }}"
                    fill-opacity="0" transform="rotate(-90 0.5 0.5)"></circle>
            </svg>
            <div class="pie-chart__bg"></div>
        </div>
        <div class="pie-chart__text">
            {{ score }}<small class="pie-chart__bg__text-small">/{{ max_score }}</small>
        </div>
    </div>
{% if is_large %}</div>{% endif %}

web/templates/partials/topic_list.html
<ul class="topic-list {{ cssClass }}">
    {% for topic in topics %}
    <li class="topic-pill">{{ topic }}</li>
    {% endfor %}
</ul>

web/templates/partials/validator_reports_summary.html
{% load don_extras %}
{% for validator_report in validator_reports %}
{% with report=validator_report.report %}
<div class="validator-report-summary card card--padding-md mb-sm">
    <div class="validator-report-summary__text">
        <h3 class="validator-report-summary__text__title mb-xs mt-0">{{ report.ruleset.title }}</h3>
        <p class="validator-report-summary__text__p">
            {{ report.ruleset.description | urlize }}
        </p>
    </div>
    {% score_pie report is_large=True %}
</div>
{% endwith %}
{% endfor %}